/*
 * 
 *  dynamic linker command file
 *  generated: Fri Jan 31 17:42:56 2025

 *  kernel   : brickOS
 *  app start: 0xadbc
 * 
 *  BrickOS for LEGO(R) Mindstorms(TM)
 *  Originally: legOS - the independent LEGO Mindstorms OS
 *              (c) 1999 by Markus L. Noga <markus@noga.de>    
 * 
 */

OUTPUT_FORMAT("symbolsrec")
OUTPUT_ARCH(h8300)
ENTRY("_main")

MEMORY {
  rom   : o = 0x0000, l = 0x8000
  kern  : o = 0x8000, l = 0x2dbc
  ram   : o = 0xadbc, l = 0x5140
  stack : o = 0xfefc, l = 0x0004
  eight : o = 0xff00, l = 0x0100
}

SECTIONS {

  .rom : {
    /* used rom functions */
    
    _rom_reset_vector = 0x0000;
        
    _reset        = 0x03ae ;
    lcd_show      = 0x1b62 ;
    lcd_hide      = 0x1e4a ;
    lcd_number    = 0x1ff2 ;
    lcd_clear     = 0x27ac ;
    power_init    = 0x2964 ;
    sound_system  = 0x299a ;
    power_off     = 0x2a62 ;
    sound_playing = 0x3ccc ;

    _rom_dummy_handler   = 0x046a ;
    _rom_ocia_handler    = 0x04cc ;
    _rom_ocia_return     = 0x04d4 ;
    
  } > rom

  .kernel :	{
    /* kernel symbols (relative to 0x8000) */
    _rom_reset_vector = 0xffff8000 ;
    _reset = 0xffff83ae ;
    rom_memcpy = 0xffff842a ;
    _rom_dummy_handler = 0xffff846a ;
    _rom_ocia_handler = 0xffff84cc ;
    _rom_ocia_return = 0xffff84d4 ;
    lcd_show = 0xffff9b62 ;
    lcd_hide = 0xffff9e4a ;
    lcd_number = 0xffff9ff2 ;
    lcd_clear = 0xffffa7ac ;
    power_init = 0xffffa964 ;
    sound_system = 0xffffa99a ;
    power_off = 0xffffaa62 ;
    sound_playing = 0xffffbccc ;
    _kmain = 0x001a ;
    _mm_try_join = 0x0120 ;
    _mm_defrag = 0x015c ;
    _mm_update_first_free = 0x0196 ;
    _mm_init = 0x01b8 ;
    _malloc = 0x0216 ;
    _free = 0x02b6 ;
    _calloc = 0x02e0 ;
    _mm_reaper = 0x0328 ;
    _mm_free_mem = 0x0356 ;
    _clock_handler = 0x038e ;
    _subsystem_handler = 0x03b2 ;
    _task_switch_handler = 0x0414 ;
    _systime_tm_return = 0x042e ;
    _get_system_up_time = 0x0442 ;
    _systime_shutdown = 0x0458 ;
    _systime_init = 0x046a ;
    _systime_set_switcher = 0x04e0 ;
    _systime_set_timeslice = 0x04e6 ;
    _tm_switcher = 0x0504 ;
    _yield = 0x0520 ;
    _tm_scheduler = 0x053c ;
    _tm_start = 0x06ce ;
    _execi = 0x06e0 ;
    _tm_init = 0x0892 ;
    _exit = 0x0908 ;
    _wait_event = 0x092a ;
    _msleep = 0x095e ;
    _tm_battery_task = 0x0994 ;
    _tm_man_task = 0x09d8 ;
    _sleep = 0x0a92 ;
    _shutdown_task = 0x0aa8 ;
    _shutdown_tasks = 0x0ab4 ;
    _kill = 0x0b08 ;
    _killall = 0x0b40 ;
    _sem_trywait = 0x0bc4 ;
    _sem_event_wait = 0x0bdc ;
    _sem_wait = 0x0bf4 ;
    _sem_timedwait = 0x0c64 ;
    _cputc_native_0 = 0x0cac ;
    _cputc_native_1 = 0x0ce0 ;
    _cputc_native_2 = 0x0d14 ;
    _cputc_native_3 = 0x0d4c ;
    _cputc_native_4 = 0x0d84 ;
    _cputc_native_5 = 0x0dbc ;
    _cputc_native = 0x0dc8 ;
    _delay = 0x0df8 ;
    _cputw = 0x0e1a ;
    _cputs = 0x0e5a ;
    _cls = 0x0ea2 ;
    _lcd_number = 0x0eaa ;
    _lcd_refresh_next_byte = 0x0ebe ;
    _lcd_refresh_next_byte_core = 0x0f5a ;
    _lcd_refresh = 0x0f9c ;
    _lcd_power_on = 0x0fbc ;
    _lcd_power_off = 0x0fce ;
    _lcd_init = 0x0fea ;
    _rx_handler = 0x1030 ;
    _rxerror_handler = 0x1044 ;
    _txend_handler = 0x105a ;
    _tx_handler = 0x1070 ;
    _rx_core = 0x1086 ;
    _rxerror_core = 0x10f0 ;
    _txend_core = 0x1136 ;
    _tx_core = 0x1144 ;
    _lnp_logical_shutdown = 0x1168 ;
    _lnp_logical_init = 0x118a ;
    _lnp_logical_write = 0x1232 ;
    _lnp_integrity_reset = 0x12f8 ;
    _lnp_timeout_reset = 0x130e ;
    _lnp_integrity_active = 0x1324 ;
    _lnp_timeout_set = 0x1330 ;
    _lnp_integrity_write = 0x133a ;
    _lnp_addressing_write = 0x139e ;
    _lnp_receive_packet = 0x142a ;
    _lnp_integrity_byte = 0x14a6 ;
    _lnp_integrity_reset_core = 0x163c ;
    _lnp_timeout_reset_core = 0x1668 ;
    _lnp_init = 0x1672 ;
    _msg_received = 0x16a0 ;
    _send_msg = 0x1702 ;
    _lr_getdata = 0x1760 ;
    _lr_process = 0x1786 ;
    _lr_waitdata = 0x1800 ;
    _lr_thread = 0x183c ;
    _lr_init = 0x1870 ;
    _lr_startup = 0x187a ;
    _lr_shutdown = 0x18be ;
    _program_valid = 0x18d2 ;
    _program_stop = 0x19ba ;
    _key_handler = 0x1d2c ;
    _lrkey_handler = 0x1fca ;
    _program_init = 0x21c4 ;
    _program_shutdown = 0x2222 ;
    _vis_handler = 0x222e ;
    _vis_core = 0x2242 ;
    _get_battery_mv = 0x229c ;
    _autoshutoff_check = 0x22c6 ;
    _shutoff_restart = 0x22da ;
    _shutoff_init = 0x22ea ;
    _autoshutoff_check_core = 0x22f6 ;
    _dkey_handler = 0x2326 ;
    _dkey_pressed = 0x2364 ;
    _dkey_released = 0x2386 ;
    _getchar = 0x23a6 ;
    _motor_a_dir = 0x23ce ;
    _motor_b_dir = 0x240c ;
    _motor_c_dir = 0x244c ;
    _dm_shutdown = 0x248c ;
    _dm_init = 0x24b0 ;
    _ds_rotation_set = 0x250a ;
    _ds_rotation_handler = 0x255a ;
    _ds_init = 0x25ec ;
    _ds_shutdown = 0x2622 ;
    _dsound_handler = 0x263a ;
    _dsound_stop = 0x264e ;
    _dsound_core = 0x266c ;
    _dsound_init = 0x2756 ;
    _dsound_shutdown = 0x276e ;
    _dsound_finished = 0x2774 ;
    _atomic_inc = 0x2786 ;
    _atomic_dec = 0x2794 ;
    _locked_check_and_increment = 0x27a2 ;
    _wait_critical_section = 0x27dc ;
    _enter_critical_section = 0x27fe ;
    _setjmp = 0x282c ;
    _longjmp = 0x2848 ;
    _memcpy = 0x285c ;
    _memset = 0x286c ;
    ___mulhi3 = 0x287a ;
    ___udivhi3 = 0x288a ;
    ___mulsi3 = 0x289c ;
    ___divsi3 = 0x28b8 ;
    _ascii_display_codes = 0x2902 ;
    _hex_display_codes = 0x2982 ;
    _lnp_rcx_msg_op = 0x29a4 ;
    _lnp_rcx_remote_op = 0x29a6 ;
    _lnp_rcx_header = 0x29a8 ;
    _min_length = 0x29d2 ;
    _dm_c_pattern = 0x2a02 ;
    _dm_b_pattern = 0x2a06 ;
    _dm_a_pattern = 0x2a0a ;
    ___ctors = 0x2aec ;
    ___ctors_end = 0x2aec ;
    ___dtors = 0x2aec ;
    ___dtors_end = 0x2aec ;
    _firmware_string = 0x2aec ;
    _etext = 0x2aec ;
    _lcd_refresh_period = 0x2aee ;
    _lnp_timeout = 0x2af0 ;
    _vis_refresh_period = 0x2af2 ;
    _battery_refresh_period = 0x2af4 ;
    _auto_shutoff_secs = 0x2af6 ;
    _auto_shutoff_period = 0x2af8 ;
    _dsound_system_sounds = 0x2afa ;
    _bss_start = 0x2afc ;
    __edata = 0x2afc ;
    _lnp_hostaddr = 0x2b18 ;
    _lr_dataready = 0x2c2a ;
    _vis_refresh_counter = 0x2ce0 ;
    _battery_refresh_counter = 0x2ce2 ;
    _idle_powerdown = 0x2ce4 ;
    _auto_shutoff_elapsed = 0x2ce6 ;
    _auto_shutoff_counter = 0x2ce8 ;
    _mm_first_free = 0x2cfa ;
    _tm_timeslice = 0x2cfc ;
    _tm_current_slice = 0x2cfd ;
    _tm_switcher_vector = 0x2cfe ;
    _sys_time = 0x2d00 ;
    _ctid = 0x2d10 ;
    _td_single = 0x2d20 ;
    _nb_tasks = 0x2d34 ;
    _priority_head = 0x2d36 ;
    _nb_system_tasks = 0x2d38 ;
    _lcd_byte_counter = 0x2d3a ;
    _lcd_refresh_counter = 0x2d3b ;
    _tx_state = 0x2d3c ;
    _lnp_rcx_checksum = 0x2d40 ;
    _lnp_integrity_handler = 0x2d42 ;
    _lnp_rcx_message = 0x2d44 ;
    _lnp_rcx_temp1 = 0x2d45 ;
    _lnp_timeout_counter = 0x2d46 ;
    _lnp_addressing_handler = 0x2d50 ;
    _lnp_remote_handler = 0x2d70 ;
    _lnp_integrity_state = 0x2d72 ;
    _lnp_rcx_temp0 = 0x2d74 ;
    _lr_curkeys = 0x2d78 ;
    _lr_data = 0x2d7a ;
    _EventType = 0x2d7c ;
    _lr_handler = 0x2d7e ;
    _lr_tid = 0x2d80 ;
    _lr_timeoff = 0x2d84 ;
    _packet_len = 0x2d88 ;
    _cprog = 0x2d8a ;
    _packet_src = 0x2d8c ;
    _dkey_timer = 0x2d8e ;
    _dkey = 0x2d8f ;
    _dkey_multi = 0x2d90 ;
    _dm_a = 0x2d94 ;
    _dm_b = 0x2d98 ;
    _dm_c = 0x2d9c ;
    _ds_rotation = 0x2da0 ;
    _ds_channel = 0x2da1 ;
    _ds_rotations = 0x2da4 ;
    _ds_activation = 0x2daa ;
    _dsound_next_note = 0x2dac ;
    _dsound_internote_ms = 0x2dae ;
    _dsound_16th_ms = 0x2db0 ;
    _dsound_next_time = 0x2db4 ;
    _kernel_critsec_count = 0x2db8 ;
    _end = 0x2dba ;
    _mm_start = 0x2dba ;
    _display_memory = 0x6f43 ;
    _dm_handler = 0x7000 ;
    ___etext_hi = 0x7048 ;
    _rom_port1_ddr = 0x7d80 ;
    _rom_port2_ddr = 0x7d81 ;
    _rom_port3_ddr = 0x7d82 ;
    _rom_port4_ddr = 0x7d83 ;
    _rom_port5_ddr = 0x7d84 ;
    _rom_port6_ddr = 0x7d85 ;
    _rom_port7_pin = 0x7d86 ;
    _reset_vector = 0x7d90 ;
    _nmi_vector = 0x7d92 ;
    _irq0_vector = 0x7d94 ;
    _irq1_vector = 0x7d96 ;
    _irq2_vector = 0x7d98 ;
    _icia_vector = 0x7d9a ;
    _icib_vector = 0x7d9c ;
    _icic_vector = 0x7d9e ;
    _icid_vector = 0x7da0 ;
    _ocia_vector = 0x7da2 ;
    _ocib_vector = 0x7da4 ;
    _fovi_vector = 0x7da6 ;
    _cmi0a_vector = 0x7da8 ;
    _cmi0b_vector = 0x7daa ;
    _ovi0_vector = 0x7dac ;
    _cmi1a_vector = 0x7dae ;
    _cmi1b_vector = 0x7db0 ;
    _ovi1_vector = 0x7db2 ;
    _eri_vector = 0x7db4 ;
    _rxi_vector = 0x7db6 ;
    _txi_vector = 0x7db8 ;
    _tei_vector = 0x7dba ;
    _ad_vector = 0x7dbc ;
    _wovf_vector = 0x7dbe ;
    _stack = 0x7e00 ;
    _motor_controller = 0x7f80 ;
    _T_IER = 0x7f90 ;
    _T_CSR = 0x7f91 ;
    _T_CNT = 0x7f92 ;
    _T_OCRA = 0x7f94 ;
    _T_OCRB = 0x7f94 ;
    _T_CR = 0x7f96 ;
    _T_OCR = 0x7f97 ;
    _T_ICRA = 0x7f98 ;
    _T_ICRB = 0x7f9a ;
    _T_ICRC = 0x7f9c ;
    _T_ICRD = 0x7f9e ;
    _WDT_CSR = 0x7fa8 ;
    _WDT_CNT = 0x7fa9 ;
    _PORT1_PCR = 0x7fac ;
    _PORT2_PCR = 0x7fad ;
    _PORT3_PCR = 0x7fae ;
    _PORT1_DDR = 0x7fb0 ;
    _PORT2_DDR = 0x7fb1 ;
    _PORT1 = 0x7fb2 ;
    _PORT2 = 0x7fb3 ;
    _PORT3_DDR = 0x7fb4 ;
    _PORT4_DDR = 0x7fb5 ;
    _PORT3 = 0x7fb6 ;
    _PORT4 = 0x7fb7 ;
    _PORT5_DDR = 0x7fb8 ;
    _PORT6_DDR = 0x7fb9 ;
    _PORT5 = 0x7fba ;
    _PORT6 = 0x7fbb ;
    _PORT7 = 0x7fbe ;
    _STCR = 0x7fc3 ;
    _SYSCR = 0x7fc4 ;
    _T0_CR = 0x7fc8 ;
    _T0_CSR = 0x7fc9 ;
    _T0_CORA = 0x7fca ;
    _T0_CORB = 0x7fcb ;
    _T0_CNT = 0x7fcc ;
    _T1_CR = 0x7fd0 ;
    _T1_CSR = 0x7fd1 ;
    _T1_CORA = 0x7fd2 ;
    _T1_CORB = 0x7fd3 ;
    _T1_CNT = 0x7fd4 ;
    _S_MR = 0x7fd8 ;
    _S_BRR = 0x7fd9 ;
    _S_CR = 0x7fda ;
    _S_TDR = 0x7fdb ;
    _S_SR = 0x7fdc ;
    _S_RDR = 0x7fdd ;
    _AD_A = 0x7fe0 ;
    _AD_A_H = 0x7fe0 ;
    _AD_A_L = 0x7fe1 ;
    _AD_B = 0x7fe2 ;
    _AD_B_H = 0x7fe2 ;
    _AD_B_L = 0x7fe3 ;
    _AD_C = 0x7fe4 ;
    _AD_C_H = 0x7fe4 ;
    _AD_C_L = 0x7fe5 ;
    _AD_D = 0x7fe6 ;
    _AD_D_H = 0x7fe6 ;
    _AD_D_L = 0x7fe7 ;
    _AD_CSR = 0x7fe8 ;
    _AD_CR = 0x7fe9 ;
    /* end of kernel symbols */
  }  > kern
      
  .text BLOCK(2) :	{
    ___text = . ;
    *(.text) 	      /* must start with text for clean entry */			
    *(.rodata)
    *(.strings)
    *(.vectors)       /* vectors region (dummy) */
    *(.persist)

    ___text_end = . ;
  }  > ram

  .tors BLOCK(2) : {
    ___ctors = . ;
    *(.ctors)
    ___ctors_end = . ;
    ___dtors = . ;
    *(.dtors)
    ___dtors_end = . ;
  }  > ram

  .data BLOCK(2) : {
    ___data = . ;
    *(.data)
    *(.tiny)
    ___data_end = . ;
  }  > ram

  .bss BLOCK(2) : {
    ___bss = . ;
    *(.bss)
    *(COMMON)
    ___bss_end = ALIGN(2) ;
  }  >ram

  .stack : {
    _stack = . ; 
    *(.stack)
  }  > stack

  .eight 0xff00: {
    *(.eight)

    /* on-chip module registers (relative to 0xff00) */

    _T_IER = 0x90 ;
    _T_CSR = 0x91 ;
    _T_CNT = 0x92 ;
    _T_OCRA = 0x94 ;
    _T_OCRB = 0x94 ;
    _T_CR = 0x96 ;
    _T_OCR = 0x97 ;
    _T_ICRA = 0x98 ;
    _T_ICRB = 0x9a ;
    _T_ICRC = 0x9c ;
    _T_ICRD = 0x9e ;
    _WDT_CSR = 0xa8 ;
    _WDT_CNT = 0xa9 ;
    _PORT1_PCR = 0xac ;
    _PORT2_PCR = 0xad ;
    _PORT3_PCR = 0xae ;
    _PORT1_DDR = 0xb0 ;
    _PORT2_DDR = 0xb1 ;
    _PORT1 = 0xb2 ;
    _PORT2 = 0xb3 ;
    _PORT3_DDR = 0xb4 ;
    _PORT4_DDR = 0xb5 ;
    _PORT3 = 0xb6 ;
    _PORT4 = 0xb7 ;
    _PORT5_DDR = 0xb8 ;
    _PORT6_DDR = 0xb9 ;
    _PORT5 = 0xba ;
    _PORT6 = 0xbb ;
    _PORT7 = 0xbe ;
    _STCR = 0xc3 ;
    _SYSCR = 0xc4 ;
    _T0_CR = 0xc8 ;
    _T0_CSR = 0xc9 ;
    _T0_CORA = 0xca ;
    _T0_CORB = 0xcb ;
    _T0_CNT = 0xcc ;
    _T1_CR = 0xd0 ;
    _T1_CSR = 0xd1 ;
    _T1_CORA = 0xd2 ;
    _T1_CORB = 0xd3 ;
    _T1_CNT = 0xd4 ;
    _S_MR = 0xd8 ;
    _S_BRR = 0xd9 ;
    _S_CR = 0xda ;
    _S_TDR = 0xdb ;
    _S_SR = 0xdc ;
    _S_RDR = 0xdd ;
    _AD_A = 0xe0 ;
    _AD_A_H = 0xe0 ;
    _AD_A_L = 0xe1 ;
    _AD_B = 0xe2 ;
    _AD_B_H = 0xe2 ;
    _AD_B_L = 0xe3 ;
    _AD_C = 0xe4 ;
    _AD_C_H = 0xe4 ;
    _AD_C_L = 0xe5 ;
    _AD_D = 0xe6 ;
    _AD_D_H = 0xe6 ;
    _AD_D_L = 0xe7 ;
    _AD_CSR = 0xe8 ;
    _AD_CR = 0xe9 ;
    
    /* end of on-chip module registers */
    
  }  > eight

  .stab 0 (NOLOAD) : {
    [ .stab ]
  }

  .stabstr 0 (NOLOAD) : {
    [ .stabstr ]
  }

} /* SECTIONS */
